#add scoreboards
scoreboard objectives add hold_shift minecraft.custom:minecraft.sneak_time
scoreboard objectives add hold_shift2 minecraft.custom:minecraft.sneak_time
scoreboard objectives add elytra minecraft.dropped:minecraft.elytra
scoreboard objectives add endereye minecraft.dropped:minecraft.ender_eye
scoreboard objectives add enderpearl minecraft.dropped:minecraft.ender_pearl
scoreboard objectives add red_bed minecraft.dropped:minecraft.red_bed
scoreboard objectives add runned minecraft.custom:minecraft.sprint_one_cm

#timer
execute as @a[tag=intrain] if score $timer_on timer matches 0 run scoreboard players add @s timer 1
execute as @a[tag=intrain,scores={runned=1..}] run scoreboard players set $timer_on timer 0
execute as @a[tag=intrain,limit=1] if score $timer_on timer matches 0 run title @s actionbar ["",{"text":"Timer started! ","color":"dark_red"},{"text":" "},{"score":{"name":"@s","objective":"timer"},"color":"red"},{"text":" Ticks have passed","color":"dark_red"}]


#fly mode
replaceitem entity @a[tag=!infly] hotbar.5 minecraft:elytra{display:{Name:'[{"text":"Fly","italic":false,"color":"gold"},{"text":" "},{"text":"[Disabled]","color":"dark_red"}]',Lore:['[{"text":"Throw/drop this item to turn fly on or off!","italic":false,"color":"gray"}]']}} 1
replaceitem entity @a[tag=infly] hotbar.5 minecraft:elytra{display:{Name:'[{"text":"Fly","italic":false,"color":"gold"},{"text":" "},{"text":"[Enabled]","color":"dark_green"}]',Lore:['[{"text":"Throw/drop this item to turn fly on or off!","italic":false,"color":"gray"}]']},Enchantments:[{}]} 1
execute as @a[scores={elytra=1..},nbt={Inventory:[{Slot:5b,id:"minecraft:elytra",tag:{Enchantments:[{}]}}]}] run tag @s remove infly
execute as @a[scores={elytra=1..},nbt=!{Inventory:[{Slot:5b,id:"minecraft:elytra",tag:{Enchantments:[{}]}}]}] run tag @s add infly
execute as @a[scores={elytra=1..}] run scoreboard players set @s elytra 0
execute as @a[tag=infly,tag=intrain,scores={hold_shift=2..}] run scoreboard players remove @s hold_shift 1
execute as @a[tag=infly,tag=intrain,scores={hold_shift=4..}] run scoreboard players set @s hold_shift 2
execute as @a[tag=infly,tag=intrain,scores={hold_shift2=1..}] run scoreboard players add @s hold_shift 1
execute as @a[tag=infly,tag=intrain,scores={hold_shift2=1..}] run scoreboard players set @s hold_shift2 0
execute as @a[tag=intrain,tag=infly,scores={hold_shift=2..}] at @s if block ^ ^ ^0.5 minecraft:air run tp @s ^ ^ ^0.5
execute as @a[tag=intrain,tag=infly,scores={hold_shift=2..}] at @s run effect give @s minecraft:slow_falling 1 2 true
execute as @a[tag=intrain,tag=infly,scores={hold_shift=2..}] at @s if block ~ ~0.5 ~ minecraft:air run tp @s ~ ~0.5 ~

#set location
execute as @a[tag=intrain] run replaceitem entity @s hotbar.7 minecraft:ender_eye{display:{Name:'[{"text":"Set location","italic":false,"color":"gold"}]',Lore:['[{"text":"Drop/throw this item to set","italic":false,"color":"dark_gray"}]','[{"text":"the location you will be teleported","italic":false,"color":"dark_gray"}]','[{"text":"to when you drop the ender_pearl to","italic":false,"color":"dark_gray"}]','[{"text":"your current lucation (xyz)!","italic":false,"color":"dark_gray"}]']}} 1
execute if entity @a[tag=intrain,scores={endereye=1..}] run function train_mode:set_location
execute as @a[tag=intrain,scores={endereye=1..}] run scoreboard players set @s endereye 0
execute as @a[tag=intrain] at @e[type=minecraft:armor_stand,tag=set_xyz] run particle minecraft:dust 1 0 0 1 ~ ~0.5 ~ 0.2 0.2 0.2 0 1 force @s

#tp location
execute as @a[tag=intrain] run replaceitem entity @s hotbar.6 minecraft:ender_pearl{display:{Name:'[{"text":"Tp location","italic":false,"color":"gold"}]',Lore:['[{"text":"Drop (not throw) this item to","italic":false,"color":"dark_gray"}]','[{"text":"teleport to the location you set by","italic":false,"color":"dark_gray"}]','[{"text":"throwing/droping the ender_eye! You","italic":false,"color":"dark_gray"}]','[{"text":"can also use it as normal!","italic":false,"color":"dark_gray"}]']}} 1
execute if entity @a[tag=intrain,scores={enderpearl=1..}] run function train_mode:tp_location
execute as @a[tag=intrain,scores={enderpearl=1..}] run scoreboard players set @s enderpearl 0

#set stop timer location
execute as @a[tag=intrain] run replaceitem entity @s hotbar.8 minecraft:red_bed{display:{Name:'[{"text":"Set timer stop location","italic":false,"color":"gold"}]',Lore:['[{"text":"Throw/drop this item to set the timer","italic":false,"color":"gray"}]','[{"text":"stop location. When you stand on","italic":false,"color":"gray"}]','[{"text":"this location the timer will stop.","italic":false,"color":"gray"}]','[{"text":"It will stop and reset","italic":false,"color":"gray"}]','[{"text":"when you teleport to your location.","italic":false,"color":"gray"}]','[{"text":"The timer starts when you start","italic":false,"color":"gray"}]','[{"text":"running!. ","italic":false,"color":"gray"}]']}} 1
execute as @a[tag=intrain,scores={red_bed=1..}] run kill @e[type=minecraft:armor_stand,tag=stop_xyz]
execute as @a[tag=intrain,scores={red_bed=1..}] at @s run summon minecraft:armor_stand ~ ~ ~ {Invisible:1b,Invulnerable:1b,PersistenceRequired:1b,NoGravity:1b,Small:1b,Tags:[stop_xyz]}
execute as @a[tag=intrain,scores={red_bed=1..}] run tellraw @s {"text":"Timer stop location set!","color":"gold"}
execute as @a[tag=intrain,scores={red_bed=1..}] run scoreboard players set @s red_bed 0
execute as @a[tag=intrain] at @e[type=minecraft:armor_stand,tag=stop_xyz] run particle minecraft:dust 0 1 0 1 ~ ~0.5 ~ 0.2 0.2 0.2 0 1 force @s
execute as @a[tag=intrain] at @s if entity @e[type=minecraft:armor_stand,tag=stop_xyz,distance=0..0.7] run function train_mode:stop_timer

#disable scores
execute as @a[tag=intrain] run scoreboard players set @s level 999
execute as @a[tag=intrain] run scoreboard players operation @s jumps = $save_jumps save_stats
execute as @a[tag=intrain] run scoreboard players operation @s time = $save_time save_stats

#if no armor_stand summon one
execute at @a[tag=intrain] unless entity @e[type=minecraft:armor_stand,tag=enter_xyz] run summon armor_stand 114.65 1.50 485.38 {Invisible:1b,Invulnerable:1b,PersistenceRequired:1b,NoGravity:1b,Small:1b,Tags:[enter_xyz]}

#if no ingame tag exit train mode
execute as @a[tag=intrain,tag=!ingame] run tellraw @s {"text":"Exited train mode because you restarted or finished!","color":"dark_red"}
execute as @a[tag=intrain,tag=!ingame] run clear @s
execute as @a[tag=intrain,tag=!ingame] run tag @s remove intrain